*                                    AVERTISSEMENT

* Le gouvernement du Canada (Statistique Canada) possde tous les droits de proprit
* intellectuelle (y compris le droit d'auteur) relatifs  ce logiciel.  Sous rserve
* des modalits dcrites ci-dessous, vous obtenez une licence non exclusive et non
* transmissible d'utilisation de ce logiciel.
*
* Ce logiciel vous est fourni  tel quel , et le titulaire ne donne aucune garantie
* expresse ou implicite, ce qui comprend les garanties de qualit marchande et de
* convenance  une fin particulire mais ne se limite pas  ces garanties.  En aucune
* circonstance le titulaire ne sera responsable de dommages indirects, particuliers ou
* conscutifs, ou d'autres dommages semblables.  Ce contrat sera automatiquement rsili,
* sans pravis, si vous omettez de respecter une quelconque des modalits du contrat.;

/*******************************************************************/
/* Date: Avril 2004                                                */
/*******************************************************************/

/*********************************************************************************/
/***                                                                           ***/
/***                             MACROF_V30.SAS                                ***/
/***                             (Version 3.0.1)                               ***/
/***                                                                           ***/
/*** Ce programme calcule des estimations de variance pour diffrents types    ***/
/*** d'estimations  l'aide des poids bootstrap.   l'aide de macros SAS,      ***/
/*** ce programme peut calculer des estimations de variance pour des totaux,   ***/
/*** des ratios, et des diffrences de ratios.  Il peut aussi calculer des     ***/
/*** estimations de variance pour des paramtres de rgressions linaires ou   ***/
/*** logistiques.  Ce programme peut aussi tre modifi pour s'adapter        ***/
/*** d'autres types d'analyse.                                                 ***/
/***                                                                           ***/
/*** Ce programme contient les macros qui sont ncessaires pour utiliser le    ***/
/*** programme BOOTVARF_V30.SAS.                                               ***/
/***                                                                           ***/
/*** Ce programme est appel automatiquement par BOOTVARF_V30.SAS et AUCUNE    ***/
/*** MODIFICATION NE DEVRAIT ETRE APPORTE PAR L'UTILISATEUR (sauf pour        ***/
/*** quelques cas prcis mentionns dans BOOTVARF_V30.SAS)                     ***/
/***                                                                           ***/
/*********************************************************************************/

options ps=64 ls=120 nonotes;


*********************************************************************************
*** Section 1: Dclaration des variables macros                               ***
*********************************************************************************;

/*  Vrification si une (des) variable(s) de ventilation est (sont) utilise(s)*/ 

%let by=;
%let cla_tmp="&classes";

data _NULL_;
if substr(&cla_tmp,1,1)='.' then do;
                   call symput ('by' ,'*');
                   call symput ('classes' ,'');
                   call symput ('number',0);
				   end;
run;

* POUR OBTENIR LES MARGINALES DANS LES RESULTATS;

&by  %let cla_tmp="&classes"||' #';

&by  data _NULL_;
&by  do i=1 to 10;
&by  	call symput ('cla'||left(trim(i)),' ');
&by  end;
&by  init=1; &by  i=1; &by  fin=1; &by  stop=' ';
&by  do until (stop='#');
&by  	do until (substr(&cla_tmp,i,1)='');
&by  		call symput ('cla'||left(trim(init)),substr(&cla_tmp,fin,i-fin+1));
&by  		call symput ('number',init);
&by  		i=i+1;
&by  	end;
&by  	fin=i;
&by  	stop=substr(&cla_tmp,i+1,1);
&by  	init=init+1;
&by  end;
&by  run;


* VARIABLES SPCIFIQUES A CHAQUE VERSION DE SAS ;

data _NULL_;
if &sysver >= 8 then call symput ('inter' ,'intercept');
else call symput ('inter' ,'intercep');
run;

* VARIABLES POUR L'INDEX(section suivante):   ;

%let indx=(id=(&ident blank)); 

***************************************************************************;
*  Section 2: LECTURE DU FICHIER PRINCIPAL ET APPARIEMENT AVEC LES POIDS  *;
***************************************************************************;

OPTIONS notes;

data Mfile (index=&indx);
   set &Mfile ;
   blank=.;
run;

/* L'tape suivante lit les poids bootstrap et standardise le nom de chaque variable de poids  */
/* FWGT est le mme poids que celui inclu dans le fichier d'analyse */

OPTIONS nonotes;

data bsamp (index=&indx);
  set &bsamp;
   blank=.;
         if &bsw.1 ne '' then do; 
                           call symput ('bsw_frst' ,'&bsw.1');
                           call symput ('bsw_last' ,'&bsw.&b');
						end;

         else if &bsw.001 ne '' then do; 
                           call symput ('bsw_frst' ,'&bsw.001');
                           call symput ('bsw_last' ,'&bsw.%sysfunc(putn(&b,z3.))');
						end;
         else if &bsw.0001 ne '' then do; 
                           call symput ('bsw_frst' ,'&bsw.0001');
                           call symput ('bsw_last' ,'&bsw.%sysfunc(putn(&b,z4.))');
						end;   
run;

OPTIONS notes;


/* Apparie le fichier d'analyse avec les poids bootstrap */

     data bs_data ;
       merge Mfile (in=in1) bsamp (keep=&fwgt &ident &bsw_frst-&bsw_last);
       by &ident;
       if in1;
	   drop blank;
       rename &bsw_frst-&bsw_last=bsw1-bsw&b; 
     run;


&by  proc sort data=bs_data;
&by     by &classes;
&by  run;


* FICHIERS DE RSULTATS:     ;

data alltots allrats diffrat bs_reg bs_reglg ;
      set _NULL_;
run;

%let result= alltots allrats diffrat bs_reg bs_reglg;


/*********************************************************************************/
/*** Section 3: Dclaration des macros                                         ***/
/*********************************************************************************/

%let printtot=0;
%let printrat=0;
%let printdif=0;
%let printreg=0;
%let printlog=0;

%global dep1 dep2;

*************************************;

%macro total(var);

*************************************;

proc means data=bs_data noprint;
  var &fwgt bsw1-bsw&b;
  weight &var;
&by  class &classes;
  output out=ytot
         sum=yhat ybs1-ybs&b;
run;


proc means data=Mfile noprint;
  var &var;
  where &var>0;
&by  class &classes;
  output out=n n=n;
run;

data ytot;
	merge ytot n (drop=_type_ _freq_);
&by by &classes;
run;

     data est;
		  set ytot;
		  length var $ 8;
		  length type $ 8;
		  Estimation=yhat;
		  bs_var=((&b-1)*(var(of ybs1-ybs&b)))/&b;
		  bs_et=sqrt(bs_var);
		  bs_cv=round((bs_et/yhat)*100,.01);
		  IC_i95=yhat-1.96*bs_et;
		  IC_s95=yhat+1.96*bs_et;
		  var="&var";
		  type="Total";
		  drop ybs1-ybs&b _type_ _freq_;
&by		  drop &cla1 &cla2 &cla3 &cla4 &cla5 &cla6 &cla7 &cla8 &cla9 &cla10;

&by  			%do k=1 %to &number; 
&by  			if &&cla&k ne ' ' then cla&k=put(&&cla&k,best8.);
&by  			%end;
run;

data alltots;
	set alltots est;
run;

%let printtot=1;

proc datasets library=work;
	delete ytot est;
run;

%mend total;


*******************************************;

%macro ratio(var1,var2,);

*******************************************;

proc means data=bs_data noprint;
  var &fwgt bsw1-bsw&b;
  weight &var1;
&by  class &classes;
  output out=ytot
         sum=yhat ybs1-ybs&b;
run;

proc means data=bs_data noprint;
  var &fwgt bsw1-bsw&b;
  weight &var2;
  &by  class &classes;
  output out=xtot
  sum=xhat xbs1-xbs&b;
run;

proc means data=Mfile noprint;
  var &var1;
  where &var1>0;
&by  class &classes;
  output out=n n=n1;
run;

data ytot;
	merge ytot n (drop=_type_ _freq_);
&by by  &classes;
run;


data est;
  merge ytot xtot;
  array ybs{&b};
  array xbs{&b};
  array rbs{&b};
  length var1 $ 8;
  length var2 $ 8;
  length type $ 8;
  Estimation=((yhat/xhat));
  do i=1 to &b;
    rbs{i}=((ybs{i}/xbs{i}));
  end;
  bs_var=((&b-1)*(var(of rbs1-rbs&b)))/&b;
  bs_et=sqrt(bs_var);
  bs_cv=round((bs_et/Estimation)*100,.01);
  IC_i95=Estimation-1.96*bs_et;
  IC_s95=Estimation+1.96*bs_et;
  var1="&var1";
  var2="&var2";
  type="Ratio";
  drop ybs1-ybs&b xbs1-xbs&b rbs1-rbs&b xhat yhat i _type_ _freq_;
&by		  drop &cla1 &cla2 &cla3 &cla4 &cla5 &cla6 &cla7 &cla8 &cla9 &cla10;

&by  			%do k=1 %to &number; 
&by  			if &&cla&k ne ' ' then cla&k=put(&&cla&k,best8.);
&by  			%end;
run;

data allrats;
	set allrats est;
run;

%let printrat=1;

proc datasets library=work;
    delete ytot xtot est;
run;

%mend ratio;


********************************************************;

%macro diff_rat(var1,var2,var3,var4);

********************************************************;

proc means data=bs_data noprint;
  var &fwgt bsw1-bsw&b;
  weight &var1;
  &by  class &classes;
  output out=ytot
  sum=yhat ybs1-ybs&b;
run;

proc means data=bs_data noprint;
  var &fwgt bsw1-bsw&b;
  weight &var2;
  &by  class &classes;
  output out=xtot
  sum=xhat xbs1-xbs&b;
run;

proc means data=bs_data noprint;
  var &fwgt bsw1-bsw&b;
  weight &var3;
  &by  class &classes;
  output out=yytot
  sum=yyhat yybs1-yybs&b;
run;

proc means data=bs_data noprint;
  var &fwgt bsw1-bsw&b;
  weight &var4;
  &by  class &classes;
  output out=xxtot
  sum=xxhat xxbs1-xxbs&b;
run;

proc means data=Mfile noprint;
  var &var1;
  where &var1>0;
&by  class &classes;
  output out=n1 n=n1;
run;

proc means data=Mfile noprint;
  var &var3;
  where &var3>0;
&by  class &classes;
  output out=n3 n=n3;
run;

data ytot;
	merge ytot n1 (drop=_type_ _freq_) n3 (drop=_type_ _freq_);
&by by &classes;
run;


data est;
  merge ytot xtot yytot xxtot;
  array ybs{&b};
  array xbs{&b};
  array yybs{&b};
  array xxbs{&b};
  array drbs{&b};
  length var1 $ 8;
  length var2 $ 8;
  length var3 $ 8;
  length var4 $ 8;
  length type $ 10;
  Estimation=(((yhat/xhat)-(yyhat/xxhat)));
  do i=1 to &b;
    drbs{i}=(((ybs{i}/xbs{i})-(yybs{i}/xxbs{i})));
  end;
  bs_var=(((&b-1)*(var(of drbs1-drbs&b)))/&b);
  bs_et=sqrt(bs_var);
  bs_cv=abs(round((bs_et/Estimation)*100,.01));
  IC_i95=Estimation-1.96*bs_et;
  IC_s95=Estimation+1.96*bs_et;
  var1="&var1";
  var2="&var2";
  var3="&var3";
  var4="&var4";
  type="Dif_Rat";
  drop ybs1-ybs&b xbs1-xbs&b yybs1-yybs&b xxbs1-xxbs&b drbs1-drbs&b
       xhat yhat xxhat yyhat i _type_ _freq_;
&by		  drop &cla1 &cla2 &cla3 &cla4 &cla5 &cla6 &cla7 &cla8 &cla9 &cla10;

&by  			%do k=1 %to &number; 
&by  			if &&cla&k ne ' ' then cla&k=put(&&cla&k,best8.);
&by  			%end;
run;

data diffrat;
	set diffrat est;
run;


%let printdif=1;

proc datasets library=work;
   delete ytot xtot yytot xxtot est;
run;

%mend diff_rat;


*********************************************;

%macro regress(yvar,xvar);

*********************************************;

proc reg data=bs_data outest=orig(keep=&classes &inter &xvar) noprint;
  model &yvar=&xvar;
  weight &fwgt;
  &by  by &classes;
run;

proc transpose data=orig out=origest(drop=_label_) prefix=beta name=param;
  var &inter &xvar;
  &by  by &classes;
run;

data _NULL_; 
    L=int((&b/10)+0.999);
    call symput ('L' , trim(left(L))); 
run;

OPTIONS nonotes;

%let j_dep=1;

%do k=1 %to 10;
  %let j=%eval(1+((&k-1)*&L));
  %let kL=%eval(&k*&L);

data _NULL_;
if (&b - &kL) >0  then do;   
                         k=&k;
                         j=1+((&k-1)*&L);
                         kL=&k*&L;
                       end;
                  else do; 
                         k=10; 
                         j=&j_dep;
                         kL=&b;
                       end;

call symput ('k' , trim(left(k)));
call symput ('j' , trim(left(j)));
call symput ('kL' , trim(left(kL)));
run;

data poids (keep = bsw&j-bsw&kL &yvar &xvar &classes);  
  set bs_data;
run;

  %do i=&j %to &kL;

   %put Regression &i termine;

   %let j_dep=%eval(&kl+1);

   proc reg data=poids outest=betas(keep=&classes &inter &xvar) noprint;
     model &yvar=&xvar;
     weight bsw&i;
&by  by &classes;
   run;

   proc transpose data=betas out=betat prefix=best name=param;
     var &inter &xvar;
&by  by &classes;
   run;

   data betat;
     set betat;
     drop _label_;
     rename best1=best&i;
	if &i=1 then test=1;
	else test=test+1;
   run;

   %if (&i =1) %then %do;

     data bsbeta;
       set betat;
     run;

   %end;
   %else %do;

     data bsbeta;
       merge bsbeta betat;
&by    by &classes;
     run;

   %end;
  %end;
%end;

OPTIONS notes;

data est;
  merge origest bsbeta;
  rename beta1=beta;
  bs_var=((&b-1)*(var(of best1-best&b)))/&b;
  bs_et=sqrt(bs_var);
  bs_cv=abs(round((bs_et/beta1)*100,.01));
  IC_i95=beta1-1.96*bs_et;
  IC_s95=beta1+1.96*bs_et;
  ydep="&yvar";
  drop best1-best&b;
run;

data bs_reg;
    set bs_reg est;
run;

%let printreg=1;
%let dep1=&yvar;

proc datasets library=work;
    delete betas betat bsbeta origest;
run;


%mend regress;

*********************************************;

%macro logreg(yvar,xvar);

*********************************************;

proc logistic data=bs_data outest=orig(keep=&classes &inter &xvar) descending noprint;
  model &yvar=&xvar;
  &by by &classes;
  weight &fwgt;
run;

proc transpose data=orig out=origest prefix=beta name=param;
  var &inter &xvar;
  &by by &classes;
run;


data _NULL_; 
    L=int((&b/10)+0.999);
    call symput ('L' , trim(left(L))); 
run;

OPTIONS nonotes;

%let j_dep=1;

%do k=1 %to 10;
  %let j=%eval(1+((&k-1)*&L));
  %let kL=%eval(&k*&L);

data _NULL_;
if (&b - &kL) >0  then do; 
                          k=&k;
                          j=1+((&k-1)*&L);
                          kL=&k*&L;
                       end;
                  else do; 
                          k=10; 
                          j=&j_dep;
                          kL=&b;
                       end;

call symput ('k' , trim(left(k)));
call symput ('j' , trim(left(j)));
call symput ('kL' , trim(left(kL)));
run;


data poids (keep = bsw&j-bsw&kL &yvar &xvar &classes);  
  set bs_data;
run;

  %do i=&j %to &kL;

  %put Regression logistique &i termine;
 
    %let j_dep=%eval(&kl+1);

    proc logistic data=poids outest=betas (keep=&classes &inter &xvar) noprint descending;
      model &yvar=&xvar;
      &by by &classes;
      weight bsw&i;
    run;



    proc transpose data=betas out=betat prefix=best name=param;
      var &inter &xvar;
      &by by &classes;
    run;

    data betat;
      set betat;
      rename best1=best&i;
    run;

    %if (&i =1) %then %do;

      data bsbeta;
        set betat;
      run;

    %end;
    %else %do;

      data bsbeta;
        merge bsbeta betat;
        &by by &classes;
      run;

    %end;
  %end;
%end;

OPTIONS notes;


data est;
  merge origest bsbeta;
  rename beta1=beta;
  bs_var=((&b-1)*(var(of best1-best&b)))/&b;
  bs_et=sqrt(bs_var);
  bs_cv=abs(round((bs_et/beta1)*100,.01));
  wald=(beta1/bs_et)*(beta1/bs_et);
  valeurp=1-probchi(wald,1);
  cotes=exp(beta1);
  lo95=beta1-1.96*bs_et;
  hi95=beta1+1.96*bs_et;
  IC_i95=exp(lo95);
  IC_s95=exp(hi95);
  ydep="&yvar";
  drop best1-best&b;
run;

data bs_reglg; 
     set bs_reglg est;
run;

%let printlog=1;
%let dep2=&yvar;

proc datasets library=work;
     delete betas betat bsbeta origest;
run;


%mend logreg;



****************;

%macro prnttot;

****************;
%if &printtot=1 %then %do;

&by  data alltots;
&by  	set alltots;
&by     ind1=3; &by  ind2=3; &by  ind3=3; &by  ind4=3;&by   ind5=3; &by  ind6=3; &by  ind7=3;&by   ind8=3;&by   ind9=3;&by   ind10=3;  
&by      %do i=1 %to &number;
&by  	     &&cla&i=cla&i;
&by  	     if &&cla&i=" " then &&cla&i="    Tous";
&by  	     if &&cla&i="    Tous" then ind&i=1;  &by  else ind&i=2;
&by  	%end;
&by  	run;

&by   proc sort data=alltots;
&by     by ind1 ind2 ind3 ind4 ind5 ind6 ind7 ind8 ind9 ind10  &classes;
&by   run;

/**********************************************/
/* Imprime les rsultats de la macro total    */
/**********************************************/

proc print data=alltots;
    	 title "Estimation de la variance  l'aide du bootstrap pour des Totaux";
    	 title2 "(&B rpliques bootstrap)";
	     title3 ;
	 var &classes type var n Estimation bs_et bs_cv IC_i95 IC_s95;
  	 format Estimation bs_et IC_i95 IC_s95 11.2;
run;

%end;

        /**********************************************************/
        /*** O:                                                ***/
        /*** type         : type d'estimation (Total)           ***/
        /*** var          : variable utilise pour calculer     ***/
        /***                les estimations                     ***/
        /*** n            : Taille d'chant. pour le total      ***/
        /*** Estimation   : estimation du paramtre             ***/
        /*** bs_et        : cart-type                          ***/
        /*** bs_cv        : coefficient de variation            ***/
        /*** IC_i95        : borne infrieure de l'intervalle de***/
        /***                confiance  95%                     ***/
        /*** IC_s95        : borne suprieure de l'intervalle de***/
        /***                confiance  95%                     ***/
        /**********************************************************/


%mend prnttot;


****************;

%macro prntrat;

****************;
%if &printrat=1 %then %do;

&by  data allrats;
&by  	set allrats;
&by     ind1=3; &by  ind2=3; &by  ind3=3; &by  ind4=3;&by   ind5=3; &by  ind6=3; &by  ind7=3;&by   ind8=3;&by   ind9=3;&by   ind10=3;  
&by      %do i=1 %to &number;
&by  	     &&cla&i=cla&i;
&by  	     if &&cla&i=" " then &&cla&i="    Tous";
&by  	     if &&cla&i="    Tous" then ind&i=1;  &by  else ind&i=2;
&by  	%end;
&by  	run;

&by   proc sort data=allrats;
&by     by ind1 ind2 ind3 ind4 ind5 ind6 ind7 ind8 ind9 ind10  &classes;
&by   run;

/**********************************************/
/* Imprime les rsultats de la macro ratio    */
/**********************************************/

proc print data=allrats;
    	 title "Estimation de la variance  l'aide du bootstrap pour des Ratios";
    	 title2 "(&B rpliques bootstrap)";
	     title3 ;
	 var &classes type var1 var2 n1 Estimation bs_et bs_cv IC_i95 IC_s95;
     format  bs_et IC_i95 IC_s95 Estimation 11.4;
run;

%end;

        /**********************************************************/
        /*** O:                                                ***/
        /*** type         : type d'estimation (Ratio)           ***/
        /*** var1 et var2 : variables utilises pour calculer   ***/
        /***                les estimations                     ***/
        /*** n1           : Taille d'chant. pour le numrateur ***/
        /*** Estimation   : estimation du paramtre             ***/
        /*** bs_et        : cart-type                          ***/
        /*** bs_cv        : coefficient de variation            ***/
        /*** IC_i95        : borne infrieure de l'intervalle de***/
        /***                confiance  95%                     ***/
        /*** IC_s95        : borne suprieure de l'intervalle de***/
        /***                confiance  95%                     ***/
        /**********************************************************/


%mend prntrat;

****************;

%macro prntdiff;

****************;
%if &printdif=1 %then %do;

&by  data diffrat;
&by  	set diffrat;
&by     ind1=3; &by  ind2=3; &by  ind3=3; &by  ind4=3;&by   ind5=3; &by  ind6=3; &by  ind7=3;&by   ind8=3;&by   ind9=3;&by   ind10=3;  
&by      %do i=1 %to &number;
&by  	     &&cla&i=cla&i;
&by  	     if &&cla&i=" " then &&cla&i="    Tous";
&by  	     if &&cla&i="    Tous" then ind&i=1;  &by  else ind&i=2;
&by  	%end;
&by  	run;

&by   proc sort data=diffrat;
&by     by ind1 ind2 ind3 ind4 ind5 ind6 ind7 ind8 ind9 ind10  &classes;
&by   run;


/**********************************************/
/* Imprime les rsultats de la macro diff_rat */
/**********************************************/

   proc print data=diffrat;
     title "Estimation de la variance  l'aide du bootstrap pour des";
     title2 "Diffrences entre des Ratios";
     title3 "(&B rpliques bootstrap)" ;
     var &classes type var1 var2 var3 var4 n1 n3 Estimation bs_et bs_cv IC_i95 IC_s95;
     format  bs_et IC_i95 IC_s95 Estimation 11.4;
   run;
%end;

        /*************************************************************/
        /*** O:                                                   ***/
        /*** type         : type d'estimation (Diff_Ratio)         ***/
        /*** var1,var2,                                            ***/
        /*** var3 et var4 : variables utilises pour calculer      ***/
        /***                l'estimation                           ***/
        /*** n1           : Taille d'chant. pour le 1er numrateur***/
        /*** n3           : Taille d'chant. pour le 2e numrateur ***/
        /*** Estimation   : estimation                             ***/
        /*** bs_et        : cart-type                             ***/
        /*** bs_cv        : coefficient de variation               ***/
        /*** IC_i95        : borne infrieure de l'intervalle de   ***/
        /***                confiance  95%                        ***/
        /*** IC_s95        : borne suprieure de l'intervalle de   ***/
        /***                confiance  95%                        ***/
        /*************************************************************/



%mend prntdiff;

****************;

%macro prntreg;

****************;
%if &printreg=1 %then %do;


/******************************************************/
/* Imprime les rsultats de la macro regress          */
/******************************************************/

   proc print data=bs_reg;
     title "Estimation de la variance  l'aide du bootstrap pour une Rgression";
     title2 "Variable dpendante: &dep1";
     title3 "(&B rpliques bootstrap)";
     var &classes param beta bs_var bs_et bs_cv IC_i95 IC_s95;
   run;
%end;

        /**********************************************************/
        /*** O:                                                ***/
        /***   param      : paramtre  estimer                 ***/
        /***   beta       : estimation du paramtre             ***/
        /***   bsvar      : variance de l'estimation du paramtre */
        /***   bs_et      : cart-type de l'estimation du       ***/
        /***                paramtre                           ***/
        /***   bs_cv      : coefficient de variation de l'esti- ***/
        /***                mation du paramtre                 ***/
        /***   IC_i95     : borne infrieure de l'intervalle de ***/
        /***                confiance  95%                     ***/
        /***   IC_s95     : borne suprieure de l'intervalle de ***/
        /***                confiance  95%                     ***/
        /**********************************************************/


%mend prntreg;

****************;

%macro prntlog;

****************;
%if &printlog=1 %then %do;

/********************************************/
/* Imprime les rsultats de la macro logreg */
/********************************************/

   proc print data=bs_reglg;
     title "Estimation de la variance  l'aide du bootstrap pour une Rgression Logistique";
     title2 "Variable dpendante: &dep2";
     title3 "(&B rpliques bootstrap)";
         var  &classes param beta cotes wald valeurp bs_var bs_et bs_cv IC_i95 IC_s95;
	 run;
%end;

        /**********************************************************/
        /*** O:                                                ***/
        /***   param      : paramtre  estimer                 ***/
        /***   beta       : estimation du paramtre             ***/
        /***   cotes      : rapport de cotes                    ***/
        /***   wald       : statistique de Wald                 ***/
        /***   valeurp    : valeur p de la statistique de Wald  ***/
        /***   bsvar      : variance de l'estimation du paramtre */
        /***   bs_et      : cart-type de l'estimation du       ***/
        /***                paramtre                           ***/
        /***   bs_cv      : coefficient de variation de         ***/
        /***                l'estimation du paramtre           ***/
        /***   IC_i95     : borne infrieure de l'intervalle de ***/
        /***                confiance  95% du rapport de cotes ***/
        /***   IC_s95     : borne suprieure de l'intervalle de ***/
        /***                confiance  95% du rapport de cotes ***/
        /**********************************************************/


%mend prntlog;



****************;

%macro output;

****************;

	%prnttot;
	%prntrat;
	%prntdiff;
	%prntreg;
	%prntlog;

	proc datasets library=work;
	      delete Mfile bsamp version tmp;
	run;
	quit;

%mend output;



/* Fin du programme SAS MACROF_V30.SAS */
