******************************************************************************************************
*                                                STEP1.SPS                                                           *
*                                                                                                                             *
*  This program creates the SPSS datafile containing the necessary variables for the     *
*  BOOTVARE_V30.SPS program.                                                                            *
*                                                                                                                             *
*  IT IS NOT NECESSARY TO USE THIS PROGRAM.  Dichotomous variables can       *
*  be computed directly in the Data Editor window and the analysis data file can be       *
*  created from there.                                                                                               *    
******************************************************************************************************.

SET COM NO HEA ON MES ON ERR ON RES ON JOU ON LEN NONE WID 132 PRI NO MPR NO.

					
* Creation of the SPSS "sav" file containing the variables and cases required for the analysis. Note
* that this file should be as small as possible (containing only necessary variables and cases) in
* order to reduce time and memory requirements especially if regression type analysis are to be done.

  

DEFINE !Go()
!LET !Layout = ' name_and_location_of_layout ' 
!LET !DataIn = ' name_and_location_of_source_file '       
!LET !DataOut = ' name_of_resulting_file_in_SPSS_format '                       /* <- (analysis file to be used in BOOTVARE_V30.SPS)


* Do not modify the following block of instructions.
FILE HANDLE INFILE/NAME = !QUOTE(!DataIn).   
INCLUDE FILE=!QUOTE(!Layout).
SET PRI ON.


****************************************************************************************************************
* Creation of Dichotomous Variables ( -> REPLACE all following instructions (up to "SAVE"  )    *
* (examples are presented below using NPHS cycle 3 variables)                                               *
****************************************************************************************************************.

NUMERIC diab males females mdiab fdiab.

IF (ccc8_1j=1)   diab=1.
IF (ccc8_1j~=1) diab=0.

IF (sex=1) males=1.
IF (sex~=1) males=0.
IF (sex=2) females=1.
IF (sex~=2) females=0.

compute mdiab = males*diab.
compute fdiab  =  females*diab.

execute.

********************************************************************************************.

SAVE OUTFILE !QUOTE(!DataOut)
	/KEEP =  list of variables to keep  .

          * It is recommended that only the necessary variables be kept      *
          * in order to reduce the runtime of BOOTVARE_V30.SPS.            *
          * IMPORTANT:  the identification variables and, if necessary,        *
          * the breakdown variable (ex: province, sex) must be kept. The      *
          * weight variable also must be kept if point estimates are              *
          * calculated at this step                                                             *.


* Replace "SAVE" by "XSAVE" in previous command if point estimates are desired at this time.

***   DO NOT FORGET TO RUN THE LAST LINES OF THE PROGRAM (AFTER THE EXAMPLE)  ***.


*******************************************
* Calculation of point estimates        *
* Suggested, but not required...        *
*******************************************.

*** Examples: ***.

WEIGHT BY weight_variable.

FREQ VAR=variable list.
LOGISTIC REG VAR=var WITH variable list /PRI SUM
	/CRI BCO(0.0001) LCO(0) ITE(25) EPS(10E-12).

WEIGHT OFF.


* DO NOT DELETE the following instructions
****************************************************.

SET PRI NO.
!ENDDEFINE /* !Go.

SET MPR ON.
!Go.
SET MPR NO.
